/* Bantam Java Compiler and Language Toolset.

   Copyright (C) 2009 by Marc Corliss (corliss@hws.edu) and 
                         David Furcy (furcyd@uwosh.edu) and
                         E Christopher Lewis (lewis@vmware.com).
   ALL RIGHTS RESERVED.

   The Bantam Java toolset is distributed under the following 
   conditions:

     You may make copies of the toolset for your own use and 
     modify those copies.

     All copies of the toolset must retain the author names and 
     copyright notice.

     You may not sell the toolset or distribute it in 
     conjunction with a commerical product or service without 
     the expressed written consent of the authors.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS 
   OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE 
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
   PARTICULAR PURPOSE. 
*/

package cfg;

/** A class representing a three-address code parameter instruction 
  * (StdParamInst).  A standardf parameter instruction consists of a 
  * source value representing the actual parameter expression (inherited
  * from ParamInst).  From TACInst it also inherits an opcode (STDPARAM).
  * 
  * @author Marc Corliss and Lori Pietraszek
  * */
public class StdParamInst extends ParamInst {
    /** StdParamInst constructor
      * @param source source value representing the actual parameter expression
      * */
    public StdParamInst(String source) {
	super(TACInst.STDPARAM, "stdparam", source);

	// no additional error checking is necessary beyond what's done in parent
    }
}
